require_relative "spec_helper"

describe Gemnigma::CharMap do
  it "should be a module" do
    expect(Gemnigma::CharMap.class).to eql(Module)
  end
  
  it "should have a method, #generate_char_map" do
      expect(Gemnigma::CharMap.methods.include? :generate_char_map).to be true
  end

  describe "#generate_char_map" do
    it "should return an array" do
      expect(Gemnigma::CharMap.generate_char_map.class).to eql(Array)
    end

    it "should return an array of 39 characters" do
      expect(Gemnigma::CharMap.generate_char_map.length).to eql(39)
    end

    it "should return alphabets as it's first 26 characters" do
      alphabets =  ["a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", 
                    "r", "s", "t", "u", "v", "w", "x", "y", "z", "0"]
      expect(Gemnigma::CharMap.generate_char_map[0..26]).to eql(alphabets)
    end

    it "should return numbers as strings as the next 10 characters" do
      numbers = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]
      expect(Gemnigma::CharMap.generate_char_map[26...36]).to eql(numbers)
    end

    it "should return an empty string, a period and a comma as the last 3 characters" do
      others = [" ", ".", ","]
      expect(Gemnigma::CharMap.generate_char_map.last(3)).to eql(others)
    end
  end

end