require_relative "spec_helper"

describe Gemnigma::CipherEncrypt do
  it "should be a module" do
    expect(Gemnigma::CipherEncrypt.class).to eql(Module)
  end

  it "should have a method #rotate_forward" do
    expect(Gemnigma::CipherEncrypt.methods.include? :rotate_forward).to be true
  end

  describe "#rotate_forward" do
    context "without parameters" do
      it "should raise an exception" do
        expect { Gemnigma::CipherEncrypt.rotate_forward }.to raise_error(ArgumentError)
      end
    end

    context "with parameters" do
      it "should return a hash" do
        expect(Gemnigma::CipherEncrypt.rotate_forward(3).class).to eql(Hash)
      end

      it "should return a hash with a length of 39" do
        expect(Gemnigma::CipherEncrypt.rotate_forward(3).length).to eql(39)
      end

      it "should rotate characters by passed in rotation number" do
        expect(Gemnigma::CipherEncrypt.rotate_forward(1)["a"]).to eql("b")
        expect(Gemnigma::CipherEncrypt.rotate_forward(1)[","]).to eql("a")
        expect(Gemnigma::CipherEncrypt.rotate_forward(12)["a"]).to eql("m")
       end

       it "should not rotate characters when 0 is passed in or multiples of 39" do
          expect(Gemnigma::CipherEncrypt.rotate_forward(0)["a"]).to eql("a")
          expect(Gemnigma::CipherEncrypt.rotate_forward(39)["n"]).to eql("n")
          expect(Gemnigma::CipherEncrypt.rotate_forward(78)["n"]).to eql("n")
          expect(Gemnigma::CipherEncrypt.rotate_forward(117)["a"]).to eql("a")
       end
    end
  end

end