require_relative "spec_helper"

describe Gemnigma::Key do
  before :each do
    @key = Gemnigma::Key.new(41521)
  end

  it "should return Key as it's class name" do
    expect(@key).to be_an_instance_of Gemnigma::Key
  end

  describe "#initialize" do
    context "when called with parameter" do
      it "should initialize a new instance with the specified key" do
        key = Gemnigma::Key.new(12345)
        expect(key.key).to eql(12345)
      end
    end

    context "when called without parameter" do
      it "should default to 41521 if no key is specified" do
        key = Gemnigma::Key.new
        expect(key.key).to eql(41521)
      end 
    end

    context "when called with wrong parameter value" do
      it "should default to 41521 if key is invalid" do
        key = Gemnigma::Key.new("12345")
        expect(key.key).to eql(41521)
      end
    end
  end

  describe "#key_map" do
    it "should return an array when called" do
      expect(@key.key_map.class).to eql(Array)
    end

    it "should return an array with a length of 4" do
      expect(@key.key_map.length).to eql(4)
    end

    it "should return an array of consecutive numbers based on the key" do
      expect(@key.key_map).to eql([41, 15, 52, 21])
    end
  end
end